#ifndef __DEFINES_HH
#define __DEFINES_HH
//
//  Project   : 
//  File      : defines.hh
//  Author    : Ronald Kriemann
//  Purpose   : common definitions
//  License   : GPL
//

#include "types.hh"

#ifdef SUNOS
#  ifdef LONG_MAX
#    undef LONG_MAX
#  endif
#  ifdef ULONG_MAX
#    undef ULONG_MAX
#  endif
#  define  LONG_MAX   2147483647L
#  define  ULONG_MAX  4294967295UL
#endif

// common settings
#ifndef FALSE
#define FALSE 0
#endif

#ifndef false
#define false 0
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef true
#define true 1
#endif

// functions
#define SGN( a ) ((a) >= 0   ? 1   : -1)
#define MIN(x,y) ((x) <  (y) ? (x) : (y))
#define MAX(x,y) ((x) >  (y) ? (x) : (y))
#define ABS(x)   ((x) >= 0   ? (x) : -(x))

// some mathimatical constants
#ifndef PI
#  define PI  M_PI
#endif

#ifndef PI2
#  define PI2 (PI + PI)
#endif

#ifndef PI4
#  define PI4 (PI2 + PI2)
#endif

#ifndef SQRT2
#  define SQRT2 M_SQRT2
#endif

#ifdef __GNUC__
#  define  __TMPL_FRIEND__ <>
#else
#  define  __TMPL_FRIEND__
#endif

#endif			// __DEFINES_HH
